;;; programm zum sortieren(manuell) von
;;; attributen
;;;P. Heuser 2001
;;;V0.1
(defun Fehler (s)
  ;(princ (strcat "Fehler ") s)
  (command "_UNDO" "_BACK")
  (setq *error* md_err)
  (princ)
  )


(defun getatt ( / auswahl i)
	(setq i 0)
	(setq elist nil)
	(setq auswahl (ssget "X"
						 (list
							   (cons 0 "ATTDEF")
						 )
				  )
	)
  (if
    auswahl
	(setq anzahl (sslength auswahl))
    (setq anzahl (length auswahl))
    )
	(if (<= anzahl 1)
		(progn
			(alert "\nAnzahl der Attribute muss grer 1 sein!")
			(exit)
		)
	)
	(while (> anzahl i)
		(setq elist (append
						(list
							  (entget
									  (ssname auswahl i)
							  )
						)
						elist
					)
		)
		(setq i (1+ i))
	)
	elist
)
;-------------------------------------------------------------------- 
(defun getattlist (elist / elist)
	(while elist
		(setq attlist (cons (cdr
								 (assoc 3
										(car elist)
								 )
							) attlist
					  )
		)
		(setq elist (cdr elist))
	)
	(setq attlist (reverse attlist))
)

;---------------------------------------------------------------------
(defun dialog (elist / attlist dcl_id
		       oldelist what-next
			  )
	(setq oldelist elist)
	(setq attlist nil)
	(setq attlist (getattlist elist))
	(setq dcl_id (load_dialog "attsort.dcl"))
	(if (not (new_dialog "attsort" dcl_id))
          (progn
            (alert "Dialogsteuerungsdatei 'attsort.dcl' befindet sich nicht in einem Supportpfad")
		(exit)
            );ende progn
	)	;list box fllen
	(start_list "di_attlist")
	(mapcar
		'add_list
		attlist
	)
	(end_list)
	(action_tile "di_attlist" "(listbox)")
	(action_tile "di_aendern" "(aendern)(done_dialog)")
	(action_tile "di_ho" "(hoch)")
	(action_tile "di_ru" "(runter)")
	(action_tile "cancel"
				 "(done_dialog 0)"
	)
	(setq what-next
		  (start_dialog)
	)
	(unload_dialog dcl_id)
)
;---------------------------------------------------------------------
(defun aendern (/ loeschlist)
	(setq loeschlist elist)
	(while (cdaar loeschlist)
		(entdel (cdaar loeschlist))
		(setq loeschlist (cdr loeschlist))
	)
	(while (car elist)
		(entmake (cdar elist))
		(setq elist (cdr elist))
	)
	(princ "\nAttributreihenfolge gndert!")
)
;---------------------------------------------------------------------
(defun listbox ()
	(if (= (atoi (get_tile "di_attlist"))
		   0
		)
		(mode_tile "di_ho" 1)
		(mode_tile "di_ho" 0)
	)
	(if (= (atoi (get_tile "di_attlist"))
		   (1- anzahl)
		)
		(mode_tile "di_ru" 1)
		(mode_tile "di_ru" 0)
	)
)
;---------------------------------------------------------------------
(defun hoch (/ akt-att high-ele low-ele)
	(mode_tile "di_aendern" 0)
	(setq akt-att (atoi
						(get_tile "di_attlist")
				  )
	);akt. att-nummer holen
	(setq high-ele (nth akt-att elist))
	(setq low-ele (nth (1- akt-att) elist))
	(setq elist (subst
					(list "dummy")
					high-ele
					elist
				)
	)
	(setq elist (subst
					high-ele
					low-ele
					elist
				)
	)
	(setq elist (subst
					low-ele
					(list "dummy")
					elist
				)
	)
	(start_list "di_attlist" 1
				(1- akt-att)
	)
	(add_list (cdr (assoc 3 high-ele)))
	(end_list)
	(start_list "di_attlist" 1 akt-att)
	(add_list (cdr (assoc 3 low-ele)))
	(end_list)
	(if (= (1- akt-att) 0)
		(mode_tile "di_ho" 1)
	)
	(set_tile "di_attlist" (itoa
								 (1- akt-att)
						   )
	)
	(listbox)
)
;---------------------------------------------------------------------
(defun runter (/ akt-att high-ele low-ele)
	(mode_tile "di_aendern" 0)
	(setq akt-att (atoi
						(get_tile "di_attlist")
				  )
	);akt. att-nummer holen
	(setq high-ele (nth (1+ akt-att)
						elist
				   )
	)
	(setq low-ele (nth akt-att elist))
	(setq elist (subst
					(list "dummy")
					high-ele
					elist
				)
	)
	(setq elist (subst
					high-ele
					low-ele
					elist
				)
	)
	(setq elist (subst
					low-ele
					(list "dummy")
					elist
				)
	)
	(start_list "di_attlist" 1
				(1+ akt-att)
	)
	(add_list (cdr (assoc 3 low-ele)))
	(end_list)
	(start_list "di_attlist" 1 akt-att)
	(add_list (cdr (assoc 3 high-ele)))
	(end_list)
	(if (= akt-att (1- anzahl))
		(mode_tile "di_ru" 1)
	)
	(set_tile "di_attlist" (itoa
								 (1+ akt-att)
						   )
	)
	(listbox)
)
;--------------------------------------------------------------------
(defun c:attsort ()
    (setq	md_err	*error*
	*error*	Fehler
	)
  (command "_UNDO" "_MARK")
	(setq elist (getatt))
	(dialog elist)
	(setq elist nil
		  anzahl nil
	)
  (setq *error* md_err)
	(princ)
)
(princ "\n(c) Peter Heuser ---- starten mit attsort")
(princ "\nberarbeitet von CADwiesel 10.01")
(princ)
